var emptyPosition = '4k3/8/8/8/8/8/8/4K3 w - - 0 1'; 
 //Начальная позиция, рокировки не разрешены
var board,
  moves,
  allMoves,
  game = new Chess (emptyPosition),
  statusEl = $('#status'),
  fenEl = $('#fen'),
  movesEl = $('#moves');

var onDragStart = function(source, piece, position, orientation) { //Разрешаем перетаскивать всё
};

var onDrop = function (source, target, piece, newPos, oldPos) { //Роняем фигуру
 removeGreySquares();
 if (target === 'offboard') { //Вне доски - убрать фигуру из игры
  game.remove (source);
 }
 else if (source === 'spare') { //Притащили из коллекции - добавить фигуру в игру
  var color = piece.substring(0,1);
  var type = piece.substring(1,2).toLowerCase();
  var line = target.substring(1,2);
  if (type=='p' && (line==1 || line==8)) return 'snapback'; //пешки нельзя на 1 и 8 линию
  game.put({type: piece.substring(1,2).toLowerCase(), color: color}, target);
  if (type=='k') { //не ставить 2 королей рядом
   var board = game.board();
   var field, found = false;
   for (var i=0; i<board.length; i++) {
    for (var j=0; j<board[i].length; j++) {
     if (board[i][j]!== null && board[i][j].type==='k' && board[i][j].color!=color) { 
      field = 'abcdefgh'.substring(j,j+1) + '87654321'.substring(i,i+1);
      found = true; 
      break;
     }
    }
   }
   if (found) {
    if (Math.max(
      Math.abs(field.substring(0,1).charCodeAt(0)-target.substring(0,1).charCodeAt(0)),
      Math.abs(parseInt(field.substring(1,2))-parseInt(target.substring(1,2)))
        )<2) {
     game.remove (target);
     return 'snapback';
    }       
   }
  }
 }
 else { //Это ход по доске
  var found = false;
  var type = game.get(target);
  for (var i=0; i<moves.length; i++) { 
   if (source==moves[i].from && target==moves[i].to) { 
    if (type===null || type.type!='k') { //Ход из разрешённых, кроме взятия короля
     found = true; break; 
    }
   }
  }
  if (found) {
   game.remove (source);
   var color = piece.substring(0,1);
   var type = piece.substring(1,2).toLowerCase();
   var line = target.substring(1,2);
   if (type=='p' && (color==game.BLACK && line==1 || color==game.WHITE && line==8)) type='q';
   game.put({type: type, color: color}, target);
  }
  else return 'snapback';
 }
 updateStatus(); //Обновить статус
};

var onSnapEnd = function() { 
 //Обновить позицию после особых ходов (превращение, взятие на проходе, рокировка)
 board.position(game.fen());
 updateStatus();
};

var onMouseoutSquare = function(square, piece) { //Мышка уходит с клетки
 removeGreySquares();
};

var removeGreySquares = function() { //Убрать фон
 $('#board .square-55d63').css('background', '');
};

var onMouseoverSquare = function (square, piece) { //Мышка входит на поле
 if (piece !== false) { //Если на поле есть фигура
  var color=piece.substring(0,1); //то её цвет определяет очередность хода
  var tokens = game.fen().split(' ');
  tokens[1] = color;
  tokens[3] = '-'; //Убрать метку проходного поля (иначе не будет произвольной очередности хода)
  game.load (tokens.join(' '));
  updateStatus ();
  var value=piece.substring(1,2);
  if (value!='K') moves = game.moves ({ square: square, verbose: true, legal: false });
  else moves = game.moves ({ square: square, verbose: true, legal: true });
  allMoves = game.moves ({ legal: true }); 
  //var s='';for (var name in moves[0]) { s += name+':'+moves[0][name]+"\n"; }alert(s);
  greySquare (square); //Подсветить текущее поле
  if (moves.length === 0) return; //Если у фигуры нет ходов - выйти
  for (var i = 0; i < moves.length; i++) { //Подсветить поля, куда можно ходить
   greySquare (moves[i].to);
  }
 }
};

var greySquare = function(square) { //Непосредственно функция подсветки полей
 var squareEl = $('#board .square-' + square);
 var background = '#99ff99'; //Цвет подсветки белых полей
 if (squareEl.hasClass('black-3c85d') === true) {
  background = '#03c03c'; //Цвет подсветки чёрных полей
 }
 squareEl.css('background', background);
 if (Array.isArray(allMoves)) {
  let moveColor = 'белым';
  if (game.turn() === game.BLACK) moveColor = 'чёрным';
  let s = 'Ходов '+ moveColor +' цветом: '+allMoves.length + '<br>';
  for (let i = 0; i < allMoves.length; i++) {
   s += allMoves[i];
   if (i < allMoves.length - 1) s += ', ';
  }
  movesEl.html(s);
 }
 else movesEl.html('');
};

var updateStatus = function() { //Обновление статуса
 var status = '';
 var moveColor = 'белые';
 if (game.turn() === game.BLACK) {
  moveColor = 'чёрные';
 }
 if (game.in_checkmate() === true) { //Мат
  status = 'Вне игры, ' + moveColor + ' получили мат';
 }
 else if (game.in_draw() === true) { //Ничья
  status = 'Вне игры, ничья ';
  if (game.in_stalemate() === true) status +=  '(пат)';
  else if (game.insufficient_material() === true) status +=  '(недостаточно материала)';
 }
 else {
  status = moveColor + ' могут ходить';
  if (game.in_check() === true) { //Шах
   status += ', ' + moveColor + ' под шахом';
  }
 }
 statusEl.html(status);
 fenEl.html(game.fen());
};

var cfg = { //Конфигурация доски
 draggable: true,
 dropOffBoard: 'trash',
 sparePieces: true,
 position: emptyPosition,
 onDragStart: onDragStart,
 onDrop: onDrop,
 onMouseoutSquare: onMouseoutSquare,
 onMouseoverSquare: onMouseoverSquare,
 onSnapEnd: onSnapEnd
};
board = ChessBoard('board', cfg);
updateStatus();

function switchShow (id) { //Переключалка видимости для вывода инструкции
 var div=document.getElementById ('instructionBox');
 div.style.display = div.style.display == "none" ? "block" : "none";
 document.getElementById ('instructionLink').innerHTML = 
  div.style.display == "block" ? "СКРЫТЬ&nbsp;ИНСТРУКЦИЮ" : "ИНСТРУКЦИЯ";
 return false;
}

function setPosition (position) { //Установка позиции
 game.clear();
 var r = game.load (position);
 if (!r) {
  statusEl.html('Не могу загрузить позицию!');
  game.load (emptyPosition);
  fenEl.html(game.fen());
 }
 else {
  updateStatus ();
 }
 board.position(game.fen());
 movesEl.html('');  
}

function putFENMe () { //Задать FEN
 var fen = prompt ('Введите нотацию FEN:', '');
 if (typeof(fen) == 'string' && fen != '') {
  setPosition (fen.trim());
 }
}

function selectElement (id) { //Выделить элемент с указанным id по клику
 var element = document.getElementById (id);
 var range = document.createRange ();
 range.selectNodeContents (element);
 var sel = window.getSelection ();
 sel.removeAllRanges ();
 sel.addRange (range);
}

function reloadMe() { //Перезагрузка
 window.location.reload(true);
}